/*---------------------------------------------------------------------------

	wXiƂjx

---------------------------------------------------------------------------*/
#ifndef SATORI_H
#define SATORI_H


//---------------------------------------------------------------------------
// ėp̃c[
#include	"../_/stltool.h"
#include	"../_/simple_stack.h"

// ꂵ΂ւ̑M
#include	"../_/sender.h"

// SAORI֘A
#include	"shiori_plugin.h"

// SakuraDLLƂČĂяo邽߂̍\
#include	"SakuraDLLHost.h"

//---------------------------------------------------------------------------
// i[\

typedef string Word;
typedef strvec Talk;

#include "Families.h"
class AllWords : public Families<Word> {};
class AllTalks : public Families<Talk> {};

//---------------------------------------------------------------------------
#ifdef	_DEBUG
	#define	DBG(a)	a
#else
	#define	DBG(a)	NULL
#endif	//	_DEBUG

//---------------------------------------------------------------------------
// 萔I

static const char	ret_dlmt[3] = { 13, 10, 0 };
static const char	byte1_dlmt[2] = { 1, 0 };

// o[WƂ
extern const char* gSatoriName;
extern const char* gSatoriNameW;
extern const char* gSatoriCraftman;
extern const char* gSatoriCraftmanW;
extern const char* gSatoriVersion;
extern const char* gShioriVersion;
extern const char* gSaoriVersion;

static const int RESPONSE_HISTORY_SIZE=64;

//---------------------------------------------------------------------------

class escaper
{
	// GXP[v㕶B
	// u@\ȂJbŔAU+id+p󔒂ɒuB
	// R[hsjis̈ꕶƂĈ邪AY镶͖B_ȈāB
	static const char sm_escape_sjis_code[3];

	//map<string, int> m_str2id;
	vector<string> m_id2str;

public:
	// 󂯎AoɊi[AuGXP[vꂽvԂB
	string insert(const string& i_str);
	// Ώە񒆂Ɋ܂܂uGXP[vꂽvɖ߂B
	void unescape(string& io_str);
	// oNA
	void clear();
};

//---------------------------------------------------------------------------
class Satori : public Evalcator, public SakuraDLLHost
{

private:
	string	mBaseFolder;	// satori.dll݂̑tH_
	string	mExeFolder;		// {.exȇ݂tH_

	// NGXge
	string	mStatusLine;	// NGXg̈s
	strmap	mRequestMap;	// : Zp[gĂkey:value
	string	mRequestID;		// SHIORI/3.0 ID
	string	mRequestCommand;	// GET, NOTIFY, ...
	string	mRequestType;		// SHIORI / SAORI / MAKOTO
	string	mRequestVersion;	// 1.0, 2.x, 3.0
	bool	mIsMateria;	// ܂Ă肠͓ꏈv
	strvec	mReferences;
	enum { SAORI, SHIORI2, SHIORI3, MAKOTO2, UNKNOWN } mRequestMode;
	// i[ꂽoResponse쐬BԒl̓Xe[^XR[hB
	int		CreateResponse(strmap& oResponse);
	// SHIORI/3.0 IDOnŎn܂ĂꍇACreateResponseĂ΂
	int		EventOperation(string iEvent, map<string,string> &oResponse);

	// ߂lmap
	strmap mResponseMap;

	// u
	strmap	replace_before_dic;
	strmap	replace_after_dic;

	inimap	mCharacters;	// characters.ini̓e

	// ̃GXP[vƏ߂
	escaper m_escaper;

	// SAORI/߂Ăяoۂ̈؂ƂȂ镶Q
	set<string>	mDelimiters;

	// SẮg[N
	AllTalks	talks;
	// ` ...Wꂽ̒PB
	AllWords	words;


	// ϐ
	strmap	variables;
	// AJ[
	set<string>	anchors;

	// ϐ̏BƖ肪炵H
	void	erase_var(const string& key);

	// Iɓo^ꂽPBwordsɂ^Bsatori_savedata.txtɕۑ̂ړIB
	map<string, vector<const Word*> >	mAppendedWords; // setłȂvectorȂ̂́udF/~vɔāB

	// ߂g[N̗
	deque<string>	mResponseHistory;

	// callstack ͍̂ċAB
	simple_stack<strvec>	mCallStack;

	// P`FC
	//map<string, set<string> >	mRelationalWord;	// <P, <> > 
	//set<string>	mUsedRelation;	// <gpꂽ> Pg[NŃZbgBZbgB

	// I𕪊̋L^    map<ID, pair<NUMBER, LABEL> >@
	// 悭lAIڂƂ邾ȂSsvB܂S̎擾łĂ͖
	map<string, pair<int, string> >	question_record;

	int	second_from_last_talk;	// ŌɒĂ̌oߎ

	// Ȃł񐔁Bkey͂ȂłӏAvalue͉񐔁B
	strintmap	nade_count;
	// ȂłL
	int	nade_valid_time;
		// SecondChangeɌARbmoveȂnade_countSNAB
		// nade_countnade_sensitivityzƂ̃CxgAnade_countSNAB
	bool	insert_nade_talk_at_other_talk;	// ĂŒ̂ȂŔL
	int		nade_valid_time_initializer;	// ȂłꎝbiȂŃZbV̊j
	int		nade_sensitivity;				// Ȃł䖝񐔁i܂ł̉񐔁j


	strintmap	koro_count;	// 낱
	int	koro_valid_time;	// 낱L

	// ԊuibjBOȂقBϐ
	int	talk_interval;
	// Ԋu덷iԊuɑ΂道jϐ
	int	talk_interval_random;
	// 񎩔܂ł̎ԁBƃZbgBϐ
	int	talk_interval_count;
	// }EFCg̔{Bȗ100B
	int	rate_of_auto_insert_wait;

	// t
	string	append_at_scope_change;
	string	append_at_scope_change_with_sakura_script;
	string	append_at_talk_start;
	string	append_at_talk_end;


	// ׂǗBSentenceToSakuraScript̖ċAĂяoɏB
	int		speaker;		// b
	set<int>	speaked_speaker;		// łH
	bool	is_speaked(int n) { return speaked_speaker.find(n) != speaked_speaker.end(); }
	bool	is_speaked_anybody() { return speaked_speaker.size()>0; }
	int		characters;
	int		question_num;
	set<int>	surface_changed_before_speak;	// bOɃT[tFX؂ւwH


	// ߋ̃JbRuLBigHjŎgp
	// SentenceToSakuraScript̍ċAɓB
	simple_stack<strvec>	kakko_replace_history;	

	// bT[tFX߂Eϐ
	bool	surface_restore_at_talk;
	map<int, int>	default_surface;
	map<int, int>	surface_add_value;
	map<int, int>	next_default_surface; // rdef_surface؂芷ĂArequestł͎gȂ
	string	surface_restore_string();

	// ΂[ʒu
	map<int, bool>	validBalloonOffset;	// 1łݒ肳ꂽL [ЕƈӖBނB
	map<int, string>	BalloonOffset;

	// Ԍn擾p
#ifdef POSIX
	unsigned long tick_count_at_load, tick_count_total;
#else
	DWORD	tick_count_at_load, tick_count_total;
#endif
	
	// T[tFX
	map<int, int>	cur_surface;
	map<int, int>	last_talk_exiting_surface;
	// bXVuԁv
	bool	mikire_flag,kasanari_flag,can_talk_flag;

	// COMMUNICATE
#ifdef POSIX
	bool updateGhostsInfo() { return true; } // ȂB
#else
	bool	updateGhostsInfo();	// FMO擾
#endif
	vector<strmap>	ghosts_info;	// FMO̓ê܂܁B0͎gA1`͏ԂǂB
	strmap*	find_ghost_info(string name);	// ghosts_infoÃS[Xg̏𓾂

	string	mCommunicateFor;	// bΏۃS[XgBŐݒ肳responseTo
	set<string>	mCommunicateLog;	// bOBJԂꍇ͉bł؂

	// eZNṼOfLB
	bool	fRequestLog, fOperationLog, fResponseLog;

	// ϐɂ胊[hwꂽONB
	bool	reload_flag;
	// tH_
	strvec	dic_folder;

	// TEACHϐ
	string	teach_genre;

	// ^C}Fb܂ł̕b
	strintmap	timer;

	// vZ͑Ώۂ̂ȂJbROɒuB̂߂̃tOB
	bool	unkakko_for_calcurate;

	// g[N̗\
	map<int, string>	reserved_talk;

	// uƎCxgɂmateriaCxg̒uv̂߂̃XNvg
	string	on_loaded_script;
	string	on_unloading_script;

	// xvOC
	ShioriPlugins	mShioriPlugins;
	string	inc_call(const string&, const strvec&, strvec&, bool is_secure);

	// SH
	bool	secure_flag;

	// O̕\I
	string	last_choice_name;

	// Z[uf[^ۑ̈ÍL
	bool	fEncodeSavedata;
	// vZ邩
	enum { SACM_ON, SACM_OFF, SACM_AUTO } mSaoriArgumentCalcMode;

	// Z[uԊu
	int	mAutoSaveInterval;
	int	mAutoSaveCurrentCount;

	// 
	int	numWord, numParentheres, numSurfaceChange,
		numDictionary, numDictionarySize;

	// VXen ----------

	enum { UNDEFINED, WIN95, WIN98, WINME, WINNT, WIN2K, WINXP } mOSType;

#ifndef POSIX
	// }`j^
	bool	is_single_monitor;	// ŏʁBꂪfalseȂΈȉgĂ͂Ȃ
	RECT	desktop_rect;
	RECT	max_screen_rect;
	map<int, HWND>	characters_hwnd;
#endif

	// o֐

	void	InitMembers();

	bool	LoadDicFolder(const string& path);
	bool	LoadDictionary(const string& filename);

	string	GetWord(const string& name);

	string	KakkoSection(const char*& p);
	string	UnKakko(const char* p);

	bool	GetURLList(const string& name, string& result);
	bool	GetRecommendsiteSentence(const string& name, string& result);

	// wCxgꍇACxg̒uioeventԂBłȂfalse
	bool	FindEventTalk(string& ioevent);

	// Communicate`BYȂȂfalseBand_modetrueȂSPvȊO͖Ƃ
	bool	TalkSearch(const string& iSentence, string& oScript, bool iAndMode);

	// VXeϐݒ莞̓
	bool	system_variable_operation(string key, string value, string* result=NULL);

	// BԒl͑s̗LBsSentenceNameGetSentenceB
	bool	GetSentence(string& ioSentenceName, string& oResultScript);

	// ]Aʂ̐^UlԂ
	bool evalcate_to_bool(const Condition& i_cond);

public:

	Satori() {}
	~Satori() {}

	// SHIORI/3.0C^tF[X
	virtual bool load(const string& i_base_folder);
	virtual bool unload();
	virtual int	request(
		const string& i_protocol,
		const string& i_protocol_version,
		const string& i_command,
		const strpairvec& i_data,
		
		string& o_protocol,
		string& o_protocol_version,
		strpairvec& o_data);

	// ϐ̃f[^t@Cɕۑ
	bool	Save(bool isOnUnload=false);	

	// strvec炳XNvg𐶐
	string	SentenceToSakuraScript(const strvec& vec);
	// strvecɃvvZX|AXNvg𐶐BƂėp
	string	SentenceToSakuraScript_with_PreProcess(const strvec& vec);
	// w肳ꂽÓ擾
	string	GetSentence(const string& name);
	// ɓnꂽ̖̂OłƂAuΏۂΒuB
	bool	Call(const string& word, string& result);
	string	Call(const string& word) { string result; Call(word, result); return result; }
	// Xxł̌vZsB߂l͐ہB
	bool calculate(const string& iExpression, string& oResult);

	// ŏIuBũXNvggisĂȂĂꏏjƔffalseԂB
	bool	Translate(string& script);

};

//---------------------------------------------------------------------------
string	int2zen(int i);
string	zen2han(string str);
bool	calc(string&);
void	diet_script(string&);
#ifndef POSIX
int		random();
#endif




//---------------------------------------------------------------------------
#endif


