#include	"satori.h"

inline bool	is_empty_script(const string& script) {
	for ( const char* p = script.c_str() ; *p!='\0' ; ) {
		if ( p[0]=='\\' ) {
			if ( p[1]=='0' || p[1]=='1' ) {
				p+=2;
				continue;
			}
			else if ( p[1]=='p' && p[2]=='[' ) {
				p+=3;
				while ( *p != ']' )
					if ( *p == '\0' )
						return	false;
					else
						++p;
				continue;
			}
		}
		return	false;
	}
	return	true;
}

int	Satori::EventOperation(string iEvent, map<string,string> &oResponse)
{
	// g[N擪ɁuvƐݒ肳B""̂܂܁B
	mCommunicateFor="";
	// XNvg
	string	script="";

	// VXe~EĂ
	if ( iEvent=="OnSecondChange" || iEvent=="OnMinuteChange" ) {

#ifndef POSIX
		if ( characters_hwnd[0]==NULL && updateGhostsInfo() && !ghosts_info.empty() ) {
			sender << "FMOhwnd擾܂B" << endl;
			characters_hwnd[0] = (HWND)(stoi( (ghosts_info[0])["hwnd"] )); 
		}

		//if ( !is_single_monitor && characters_hwnd[0]!=NULL ) {
		if ( is_single_monitor ) {
			//sender << "VOj^łB؂̓Ǝs܂B" << endl;
		}
		else if ( characters_hwnd[0]==NULL ) {
			//sender << "}`j^łAhwnd擾łĂȂ߁A؂̓Ǝs܂B" << endl;

		}
		else {
		//	sender << "؂ꔻ菈" << endl;
			RECT	rc;
			::GetWindowRect(characters_hwnd[0], &rc);
			int	center = (rc.left + rc.right)/2;
			mRequestMap["Reference1"] = mReferences[1] =
				( center >= max_screen_rect.left && center <= max_screen_rect.right ) ? "0" : "1";
			/*sender << "VF̍[: " << rc.left << endl;
			sender << "VF̉E[: " << rc.right << endl;
			sender << "VF̒: " << center << endl;
			sender << "fXNgbv̍[: " << max_screen_rect.left << endl;
			sender << "fXNgbv̉E[: " << max_screen_rect.right << endl;
			sender << "؂ꔻ茋: " << mReferences[1] << endl;*/
		}
#endif

		mikire_flag = stoi(mReferences[1])!=0;
		kasanari_flag = stoi(mReferences[2])!=0;
		can_talk_flag = ( mReferences[3] != "0" );
		if ( iEvent[2]=='S' )
			++second_from_last_talk;
	}
	else if ( iEvent=="OnSurfaceChange" ) {
		cur_surface[0]=stoi(mReferences[0]);
		cur_surface[1]=stoi(mReferences[1]);
	} else if ( iEvent=="OnUpdateReady" ) {
		mReferences[0] = itos(stoi(mReferences[0])+1);
	}

	if ( (iEvent=="OnBoot" || iEvent=="OnGhostChanged") && !is_empty_script(on_loaded_script) ) {
		script = on_loaded_script;
		on_loaded_script = "";
	}
	else if ( iEvent=="OnClose" || iEvent=="OnGhostChanging" ) {
		string	on_unloading_script = GetSentence("OnSatoriClose");
		diet_script(on_unloading_script);
		if ( !is_empty_script(on_unloading_script) )
			script = on_unloading_script;
	}

	if ( !script.empty() ) {
	}
	else if ( iEvent=="OnAnchorSelect" && anchors.find(mReferences[0])!=anchors.end() ) {
		// OnAnchorSelectƂAref0dicAnchoȑ̕ꍇ
		// Cxg`ĂꍇłVXeD悷B
		script=GetSentence(mReferences[0]);
	}
	else if ( FindEventTalk(iEvent) ) {	// ̍ہA݊Cxgւ̒uɍs
		// `ĂȂ炻D悷B
		script=GetSentence(iEvent);

		// ȉ́ACxg`ĂȂꍇ̃ftHgłB
	}
	else if ( iEvent=="OnMouseDoubleClick" )
	{
		static strvec v;
		if ( v.empty() )
		{
			v.push_back("iqRjiqSj");
			v.push_back("ij");
		}
		script = SentenceToSakuraScript(v);
	}
	else if ( iEvent=="OnMouseMove" ) {
		nade_valid_time = nade_valid_time_initializer; // ȂŃZbV̗LXV
		int&	cur_nede_count = nade_count[ mReferences[4] ];
		if ( ++cur_nede_count >= nade_sensitivity ) {
#ifdef POSIX
		        int ret = 0;
#else
		        LRESULT	ret = 0;
			if ( !insert_nade_talk_at_other_talk && updateGhostsInfo() ) {
				string	hwnd_str = (ghosts_info[0])["hwnd"];
				HWND	hwnd = (HWND)(stoi(hwnd_str));
				if ( hwnd!=NULL ) {
					UINT	WM_SAKURAAPI = RegisterWindowMessage("Sakura");
					ret = ::SendMessage(hwnd, WM_SAKURAAPI, 140, 0);
				}
			}
#endif
			
			if ( ret == 0 ) {
				string	str = mReferences[3]+mReferences[4]+"Ȃł";
				if ( talks.is_exist(str) )
					script=GetSentence(str);
				sender << "Talk: " << script << endl;
			}
			nade_count.clear();
		}
	}
	else if ( iEvent=="OnChoiceSelect" ) {
		script=GetSentence(mReferences[0]);
	}
	else if ( iEvent=="OnWindowStateRestore"
		|| iEvent=="OnShellChanged"
		|| iEvent=="OnSurfaceRestore"
		|| iEvent=="N" ) {	// uNv́uOnBootvuOnGhostChangedv烊_CNg
		script=surface_restore_string();
	}
	else if ( iEvent=="I" ) {
		script = "\\-";
	}
	else if ( iEvent=="OnMouseWheel" ) {
		koro_valid_time = 3;
		koro_count[ mReferences[4] ] += 1;
		if ( koro_count[ mReferences[4] ] >= 2 ) {
			string	str = mReferences[3]+mReferences[4]+"낱";
			if ( talks.is_exist(str) ) {
				script=GetSentence(str);
				koro_count.clear();
			}
		}
	}
	else if ( iEvent=="OnRecommendsiteChoice" )
	{
		if ( GetRecommendsiteSentence("sakura.recommendsites", script) )
			NULL;
		else if ( GetRecommendsiteSentence("kero.recommendsites", script) )
			NULL;
		else if ( GetRecommendsiteSentence("sakura.portalsites", script) )
			NULL;
		else
			script="";
	}
	else if ( iEvent=="OnCommunicate" ) {	// b|ꂽ

		// Sender	iif,iqOj==User,[U,iqOjj
		if ( mReferences[0]=="user" )
			mReferences[0]="[U";

		// XNvgɘbҖt
		if ( !TalkSearch(mReferences[0]+"u"+mReferences[1]+"v", script, false) )
			script=GetSentence("COMMUNICATEYȂ");

		if ( mCommunicateFor==""  ) {	// 蓮ł؂
			sender << "XCOMMUNICATEAɑswƂɂł؂" << endl;
			mCommunicateLog.clear();
		}
		else if ( mCommunicateLog.find(script) != mCommunicateLog.end() ) {
			sender << "XCOMMUNICATEA[vɂł؂" << endl;
			script="";	// Ȃ
			mCommunicateLog.clear();
			mCommunicateFor = "";
		}
		else  if ( mCommunicateLog.find(mReferences[1]) != mCommunicateLog.end() ) {
			sender << "XCOMMUNICATEA葤[vɂł؂" << endl;
			mCommunicateLog.clear();
			mCommunicateFor = "";
		} 
		else {	// s
			sender << "XCOMMUNICATEAs" << endl;
			mCommunicateLog.insert(mReferences[1]);
			mCommunicateLog.insert(script);
		}
	}

	if ( iEvent=="OnSecondChange" ) {

		// ݂^C}̃fBNg
		for (strintmap::iterator i=timer.begin();i!=timer.end();++i)
			variables[i->first + "^C}"] = int2zen( --(i->second) );

		// Z[u
		if ( mAutoSaveInterval > 0 ) {
			if ( --mAutoSaveCurrentCount <= 0 ) {
				this->Save(false);
				mAutoSaveCurrentCount = mAutoSaveInterval;
			}
		}
	}

	diet_script(script);
	if ( is_empty_script(script) && can_talk_flag && iEvent=="OnSecondChange" ) {

		// ^C}\񔭘b
		for (strintmap::iterator i=timer.begin();i!=timer.end();++i) {
			if ( i->second < 1 ) {
				string	var_name = i->first + "^C}";
				sender << var_name << "B" << endl;
				script=GetSentence(i->first);
				timer.erase(i);
				variables.erase(var_name);
				if ( !is_empty_script(script) )
					diet_script(script);
				break;
			}
		}

		// b
		if ( is_empty_script(script) && !mikire_flag ) {
			if ( nade_valid_time>0 )
				if ( --nade_valid_time == 0 )
					nade_count.clear();
			if ( koro_valid_time>0 )
				if ( --koro_valid_time == 0 )
					koro_count.clear();
			if ( talk_interval>0 && --talk_interval_count<0 ) {
				string	iEvent="OnTalk";
				FindEventTalk(iEvent);
				script=GetSentence(iEvent);
				diet_script(script);
			}
		}
	}

	if ( is_empty_script(script) )
		return	204;	// Ȃ

	// scriptւ̕t^
	if ( is_speaked_anybody() ) {
		script = surface_restore_string() + append_at_talk_start + script + append_at_talk_end;

		// JEg
		int	dist = int(talk_interval*(talk_interval_random/100.0));
		talk_interval_count = ( dist==0 ) ? talk_interval : 
			(talk_interval-dist)+(random()%(dist*2));
	}
	script += ( iEvent=="OnClose" || iEvent=="I" ) ? "\\-" : "\\e";


	if ( !mCommunicateFor.empty() ) { // b̗L
		sender << "XCOMMUNICATEAu" << mCommunicateFor << "v֘b|" << endl;
		oResponse["Reference0"] = mCommunicateFor;
		oResponse["To"] = mCommunicateFor;
		if ( iEvent!="OnCommunicate" )
		{
			mCommunicateLog.clear(); // ̂݁Bsɂ͂ŃNA͂ȂB
		}
		//mCommunicateLog.insert(script);
	}
	oResponse["Value"]=script;

	// Pg[Nł̂ݗLȏdNA
	words.handle_talk_end();
	talks.handle_talk_end();

	// o[ʒuLȂݒ
	if ( validBalloonOffset[0] && validBalloonOffset[1] )
		oResponse["BalloonOffset"]=string()+BalloonOffset[0]+byte1_dlmt+BalloonOffset[1];

	return	200;
}



//		string	iEvent="OnTalk";
//		FindEventTalk(iEvent);
//		script = surface_restore_string() + append_at_talk_start + GetSentence(iEvent) + append_at_talk_end + "\\e";



// Communicate`BYȂ炻̃XNvg擾AYȂȂfalseB
bool	Satori::TalkSearch(const string& iSentence, string& oScript, bool iAndMode)
{
	const Talk* talk = talks.communicate_search(iSentence, iAndMode);
	if ( talk == NULL )
	{
		return false;
	}

	oScript = SentenceToSakuraScript(*talk);
	sender << oScript << endl;
	return	true;
}


