#ifndef	THREAD_H
#define	THREAD_H

#include	<windows.h>
#include	<assert.h>

class	Thread {
private:
	HANDLE	mThread;	// Xbhnh
	DWORD	mID;		// XbhID
	
	// Xbh̃C֐izj
	virtual	DWORD	ThreadMain()=0;
	// Xbh֐i_this->ThreadMainĂяoj
	static	DWORD WINAPI ThreadProc(LPVOID iThis) { return reinterpret_cast<Thread*>(iThis)->ThreadMain(); }

protected:
	LPVOID	mParam;	// XbhN̈

public:
	Thread() : mThread(NULL), mID(0), mParam(NULL) {}
	virtual	~Thread() {}

	// 쐬
	virtual	bool	create(void* iParam=NULL, bool iSuspendedCreate=false);
	// nh
	virtual	void	close();

	// Dxݒ
	virtual	BOOL	setPriority(int nPriority) { return ::SetThreadPriority(mThread, nPriority); }
	// f
	virtual	BOOL	terminate(DWORD dwExitCode=-1) { return ::TerminateThread(mThread, dwExitCode); }
	// I҂
	virtual	DWORD	waitEnd(DWORD dwTimeOut=INFINITE) { return ::WaitForSingleObject(mThread, dwTimeOut); };
	// ImF
	virtual	DWORD	isEnd() { return ( ::WaitForSingleObject(mThread, 0 ) == WAIT_OBJECT_0 );}
};

#endif	//	THREAD_H

