#ifdef POSIX
#  include "posix_utils.h"
#endif

void	Satori::InitMembers() {

	mRequestMap.clear();
	mRequestID="";

	replace_before_dic.clear();
	replace_before_dic["\\h"]="\\0";
	replace_before_dic["\\u"]="\\1";
	replace_after_dic.clear();

	mCharacters.clear();

	m_escaper.clear();

	mDelimiters.clear();
	mDelimiters.insert(",");
	mDelimiters.insert("A");
	mDelimiters.insert("");
	mDelimiters.insert("C");
	mDelimiters.insert(byte1_dlmt);

	talks.clear();
	words.clear();
	anchors.clear();
	variables.clear();

	mAppendedWords.clear();
	mResponseHistory.clear();

	question_record.clear();

	nade_count.clear();
	nade_valid_time=0;
	insert_nade_talk_at_other_talk=false;
	nade_valid_time_initializer=2;
	nade_sensitivity=60;

	koro_count.clear();
	koro_valid_time=0;

	talk_interval=0;
	talk_interval_random=10;
	talk_interval_count=0;
	rate_of_auto_insert_wait=100;

	append_at_scope_change = "\\n[half]";
	append_at_scope_change_with_sakura_script = "";
	append_at_talk_start = "";
	append_at_talk_end = "";

	assert(kakko_replace_history.size()==0);

	surface_restore_at_talk=true;
	surface_add_value.clear();
	last_talk_exiting_surface.clear();
	next_default_surface.clear();
	cur_surface.clear();
	default_surface.clear();
	last_talk_exiting_surface[1]=next_default_surface[1]=cur_surface[1]=default_surface[1]=10;

	BalloonOffset.clear();
	BalloonOffset[0] = BalloonOffset[1] = "0,0";
	validBalloonOffset.clear();

#ifdef POSIX
	// GetTickCount()WindowsŇo߃~bc炵B
	// 擾邱Ƃ͏oȂ̂ŁAG|bN~bőpI
	tick_count_at_load = posix_get_current_millis();
#else
	tick_count_at_load = ::GetTickCount();
#endif
	tick_count_total = 0;

	ghosts_info.clear();
	mCommunicateFor="";
	mCommunicateLog.clear();

	fRequestLog = true;
	fOperationLog = true;
	fResponseLog = true;

	reload_flag = false;
	dic_folder.clear();

	teach_genre="";

	timer.clear();

	unkakko_for_calcurate = false;

	on_loaded_script = "";
	on_unloading_script = "";

	//@ mShioriPlugins.clear(); // B

	secure_flag = false;

	last_choice_name="";

	fEncodeSavedata = false;
	mSaoriArgumentCalcMode = SACM_AUTO;

	reserved_talk.clear();

	second_from_last_talk=0;

	
#ifndef POSIX
	is_single_monitor = true;
	::ZeroMemory(&desktop_rect, sizeof(RECT));
	::ZeroMemory(&max_screen_rect, sizeof(RECT));
	characters_hwnd.clear();
#endif
}
