/* -*- c++ -*- */
#ifndef POSIX
#  include <windows.h>	// HMODULE,BOOL,HGLOBALƂ
#endif

#include "SaoriClient.h"

// vOC̑Ǘ
class	ShioriPlugins {

	struct CallData {	// ĂяoƂ̏
		string	mDllPath;
		strvec	mPreDefinedArguments;
		bool	mIsBasic;
	};
	struct DllData {	// DLLƂ̏
		SaoriClient	mSaoriClient;
		int	mRefCount;
	};
	map<string, CallData>	mCallData;	// ĂяoGĂяoƂ̏
	map<string, DllData>	mDllData;	// DLL̃tpXGDLLƂ̏

	string	mBaseFolder;

public:
	bool	load(const string& iBaseFolder);
	bool	load_a_plugin(const string& iPluginLine);

	string	request(const string& iCallName, const strvec& iArguments, strvec& oResults, const string& iSecurityLevel);
	void	unload();

	bool	find(string iCallName) {
		return (mCallData.find(iCallName) != mCallData.end() );
	}
};

